function test_factor ()

figure ();

fac = {@factor, @factor2, @factor6};

x = 10.^(-(10:-1:0)) .* intmax ("uint64");
t = zeros (length (fac), length (x));

for j = 1:length (fac)
  f = fac{j};
  for i = 1:length (x)
    tic;
    f (x(i));
    t(j,i) = toc;
  endfor
endfor

plot_color = {"bo-", "ro-", "mo-"};

subplot (1, 2, 1);
for j = 1:length (fac)
  loglog (x, t(j,:), plot_color{j});
  hold on;
end

legend ({"factor", "factor (patch 2)", "factor (patch 6)"}, ...
        "Location", "NorthWest");
xlabel ("Number to factor");
ylabel ("Time in seconds");
title ("factor - comparision (lower is better)");
grid on;

subplot (1, 2, 2);

for j = 1:length (fac)
  loglog (x, t(1,:) ./ t(j,:), plot_color{j});
  hold on;
end

legend ({"factor", "factor (patch 2)", "factor (patch 6)"}, ...
        "Location", "NorthWest");
xlabel ("Number to factor");
ylabel ("Speedup relative to factor");
title ("factor - comparision (higher is better)");
grid on;

endfunction

